--Toa:
--string library by leegao
function string.trim(t)
     t = string.split(t)
     s = ""
     if not t then return end
     for i, v in ipairs(t) do
          s = s.." "..v
     end
     s = string.sub(s, 2)
     return s
end

function string.split(t, b)
     local cmd = {}
     local match = "[^%s]+"
     if b then
          match = "%w+"
     end
     if type(b) == "string" then match = "[^"..b.."]+" end
     if not t then return invalid() end
     for word in string.gmatch(t, match) do
          table.insert(cmd, word)
     end
     return cmd
end

function string.qsplit(t)
     local tab = string.split(t, '"')
     if #tab == 1 then
          return string.split(tab[1])
     end
     local ret = {}
     for i, v in ipairs(tab) do
          if i%2 == 0 then
               table.insert(ret, v)
          else
               v = string.split(v)
               for _i, _v in ipairs(v) do
                    table.insert(ret, _v)
               end
          end
     end
     return ret
end
